#include <inttypes.h>
enum kbmod {
	KBMOD_CAPS    = 0x0040,
	KBMOD_NUM     = 0x0020,
	KBMOD_SCROLL  = 0x0010,
	KBMOD_TOGGLE  = 0x0070,
	KBMOD_SHIFTL  = 0x0002,
	KBMOD_SHIFTR  = 0x0001,
	KBMOD_SHIFTQ  = 0x0003,
	KBMOD_ALT     = 0x0008,
	KBMOD_ALTR    = 0x0808,
	KBMOD_ALTL    = 0x0208,
	KBMOD_ALTQ    = 0x0a08,
	KBMOD_CTRL    = 0x0004,
	KBMOD_CTRLL   = 0x0104,
	KBMOD_CTRLR   = 0x0404,
	KBMOD_CTRLQ   = 0x0504,
	KBMOD_RDP5    = 0x8000,
};
struct kbdxlat {
	uint16_t mod;
	char * codes;
};
struct kbdxlat kbdxlat_X11_x86_Lin_devinput [] = {	{ 0            , ""                         }, // -
	{ 0            , ""                         }, // -
	{ 0            , ""                         }, // -
	{ 0            , ""                         }, // -
	{ 0            , ""                         }, // -
	{ 0            , ""                         }, // -
	{ 0            , ""                         }, // -
	{ 0            , ""                         }, // -
	{ 0            , ""                         }, // -
	{ 0            , "\x01"                     }, // ESC
	{ 0            , "\x02"                     }, // A_1
	{ 0            , "\x03"                     }, // A_2
	{ 0            , "\x04"                     }, // A_3
	{ 0            , "\x05"                     }, // A_4
	{ 0            , "\x06"                     }, // A_5
	{ 0            , "\x07"                     }, // A_6
	{ 0            , "\x08"                     }, // A_7
	{ 0            , "\x09"                     }, // A_8
	{ 0            , "\x0a"                     }, // A_9
	{ 0            , "\x0b"                     }, // A_0
	{ 0            , "\x0c"                     }, // A_SUB
	{ 0            , "\x0d"                     }, // A_EQL
	{ 0            , "\x0e"                     }, // BKSPC
	{ 0            , "\x0f"                     }, // TAB
	{ 0            , "\x10"                     }, // A_Q
	{ 0            , "\x11"                     }, // A_W
	{ 0            , "\x12"                     }, // A_E
	{ 0            , "\x13"                     }, // A_R
	{ 0            , "\x14"                     }, // A_T
	{ 0            , "\x15"                     }, // A_Y
	{ 0            , "\x16"                     }, // A_U
	{ 0            , "\x17"                     }, // A_I
	{ 0            , "\x18"                     }, // A_O
	{ 0            , "\x19"                     }, // A_P
	{ 0            , "\x1a"                     }, // A_OPEN
	{ 0            , "\x1b"                     }, // A_CLOSE
	{ 0            , "\x1c"                     }, // RETURN
	{ KBMOD_CTRLL  , "\x1d"                     }, // CTRL_L
	{ 0            , "\x1e"                     }, // A_A
	{ 0            , "\x1f"                     }, // A_S
	{ 0            , "\x20"                     }, // A_D
	{ 0            , "\x21"                     }, // A_F
	{ 0            , "\x22"                     }, // A_G
	{ 0            , "\x23"                     }, // A_H
	{ 0            , "\x24"                     }, // A_J
	{ 0            , "\x25"                     }, // A_K
	{ 0            , "\x26"                     }, // A_L
	{ 0            , "\x27"                     }, // A_COLON
	{ 0            , "\x28"                     }, // A_APOST
	{ 0            , "\x29"                     }, // A_CARET
	{ KBMOD_SHIFTL , "\x2a"                     }, // SHIFTL
	{ 0            , "\x2b"                     }, // A_BSLSH
	{ 0            , "\x2c"                     }, // A_Z
	{ 0            , "\x2d"                     }, // A_X
	{ 0            , "\x2e"                     }, // A_C
	{ 0            , "\x2f"                     }, // A_V
	{ 0            , "\x30"                     }, // A_B
	{ 0            , "\x31"                     }, // A_N
	{ 0            , "\x32"                     }, // A_M
	{ 0            , "\x33"                     }, // A_COMMA
	{ 0            , "\x34"                     }, // A_PERIO
	{ 0            , "\x35"                     }, // A_SLASH
	{ KBMOD_SHIFTR , "\x36"                     }, // SHIFTR
	{ 0            , "\x37"                     }, // NPMUL
	{ KBMOD_ALTL   , "\x38"                     }, // ALTL
	{ 0            , "\x39"                     }, // SPACE
	{ KBMOD_CAPS   , "\x3a"                     }, // CAPS
	{ 0            , "\x3b"                     }, // F1
	{ 0            , "\x3c"                     }, // F2
	{ 0            , "\x3d"                     }, // F3
	{ 0            , "\x3e"                     }, // F4
	{ 0            , "\x3f"                     }, // F5
	{ 0            , "\x40"                     }, // F6
	{ 0            , "\x41"                     }, // F7
	{ 0            , "\x42"                     }, // F8
	{ 0            , "\x43"                     }, // F9
	{ 0            , "\x44"                     }, // F10
	{ KBMOD_NUM    , "\x45"                     }, // NUMLK
	{ KBMOD_SCROLL , "\x46"                     }, // SCROLL
	{ 0            , "\x47"                     }, // NP7
	{ 0            , "\x48"                     }, // NP8
	{ 0            , "\x49"                     }, // NP9
	{ 0            , "\x4a"                     }, // NPSUB
	{ 0            , "\x4b"                     }, // NP4
	{ 0            , "\x4c"                     }, // NP5
	{ 0            , "\x4d"                     }, // NP6
	{ 0            , "\x4e"                     }, // NPPLUS
	{ 0            , "\x4f"                     }, // NP1
	{ 0            , "\x50"                     }, // NP2
	{ 0            , "\x51"                     }, // NP3
	{ 0            , "\x52"                     }, // NP0
	{ 0            , "\x53"                     }, // NPDOT
	{ 0            , ""                         }, // -
	{ 0            , ""                         }, // -
	{ 0            , "\x56"                     }, // A_LESS
	{ 0            , "\x57"                     }, // F11
	{ 0            , "\x58"                     }, // F12
	{ 0            , ""                         }, // -
	{ 0            , ""                         }, // -
	{ 0            , ""                         }, // -
	{ 0            , ""                         }, // -
	{ 0            , ""                         }, // -
	{ 0            , ""                         }, // -
	{ 0            , ""                         }, // -
	{ 0            , "\x9c"                     }, // ENTER
	{ KBMOD_CTRLR  , "\x9d"                     }, // CTRLR
	{ 0            , "\xb5"                     }, // NPDIV
	{ 0            , "\x54"                     }, // PRTSCR
	{ KBMOD_ALTR   , "\xb8"                     }, // ALTR
	{ 0            , ""                         }, // -
	{ 0            , "\xc7"                     }, // HOME
	{ 0            , "\xc8"                     }, // UP
	{ 0            , "\xc9"                     }, // PGUP
	{ 0            , "\xcb"                     }, // LEFT
	{ 0            , "\xcd"                     }, // RIGHT
	{ 0            , "\xcf"                     }, // END
	{ 0            , "\xd0"                     }, // DOWN
	{ 0            , "\xd1"                     }, // PGDN
	{ 0            , "\xd2"                     }, // INS
	{ 0            , "\xd3"                     }, // DEL
	{ 0            , ""                         }, // -
	{ 0            , ""                         }, // -
	{ 0            , ""                         }, // -
	{ 0            , ""                         }, // -
	{ 0            , ""                         }, // -
	{ 0            , ""                         }, // -
	{ 0            , ""                         }, // -
	{ 0            , "\x1d\x45"                 }, // PAUSE
	{ 0            , ""                         }, // -
	{ 0            , ""                         }, // -
	{ 0            , ""                         }, // -
	{ 0            , ""                         }, // -
	{ 0            , ""                         }, // -
	{ KBMOD_RDP5   , "\xdb"                     }, // WINL
	{ KBMOD_RDP5   , "\xdc"                     }, // WINR
	{ KBMOD_RDP5   , "\xdd"                     }, // MENU
};

